// ==UserScript==
// @name			No Click to Activate
// @version			2.0
// @description	    Attempt to work around the Eolas patent nonsense affecting plugin activation in Opera
// @exclude http://*.ra.icast.cn/*
// @exclude http://www.top100.cn/*
// @exclude http://t.top100.cn/*
// ==/UserScript==

(function (opera) {
    if (!(document.documentElement instanceof window.HTMLHtmlElement)) {
        return;
    }

    var script = document.createElement('script'),
        scriptLoaded = false,
        elQueue = [];

    script.src = 'data:text/javascript,' + encodeURIComponent('opera.clickToActivate = ' + (function (el) {
        var parent = el.parentNode;
        if (parent) {
            parent.insertBefore(el, el.nextSibling);
        }
        el.setAttribute('noClickToActivate', 'activated');
    }).toString());

    script.addEventListener('load', function (e) {
        var el;
        scriptLoaded = !!this.parentNode.removeChild(this);
        while (el = elQueue.shift()) {
            opera.clickToActivate(el);
        }
    }, false);

    opera.addEventListener('PluginInitialized', function (e) {
        var el = e.element;
        if (el.hasAttribute('noClickToActivate')) {
            return;
        } else if (scriptLoaded) {
            opera.clickToActivate(el);
        } else {
            elQueue.push(el);
        }
    }, false);

    document.addEventListener('DOMContentLoaded', function (e) {
        document.removeEventListener(e.type, this, false);
        document.documentElement.appendChild(script);
    }, false);
})(window.opera);